/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: SkyPalmJobDocument.h,v 1.1 2003/07/14 16:18:25 helge Exp $

#ifndef __SkyPalmJobDocument_H__
#define __SkyPalmJobDocument_H__

#include <OGoPalm/SkyPalmDocument.h>

@interface SkyPalmJobDocument : SkyPalmDocument
{
  // record values
  NSString       *description;
  NSCalendarDate *duedate;
  NSString       *note;
  int            priority;
  BOOL           isCompleted;
}

- (BOOL)isCompleted;
- (NSString *)priorityString;
+ (NSString *)priorityStringForPriority:(int)_pri;

- (void)setDuedate:(NSCalendarDate *)_date;
- (NSCalendarDate *)duedate;
- (int)priority;
- (NSString *)note;

@end /* SkyPalmJobDocument */

@interface SkyPalmJobDocumentSelection: SkyPalmDocumentSelection
{}
@end /* SkyPalmJobDocumentSelection */

#endif /* __SkyPalmJobDocument_H__ */
